/* $Id: rectify.h,v 1.2 1994/07/01 11:54:31 queinnec Exp queinnec $ */

#ifndef _RECTIFY_H
#define _RECTIFY_H

/*
 * Translate from "surname, firstname" into "firstname surname", and then
 * capitalize every word.
 * Special care is given to attributes such as (AA).
 * Even more special care is given to false attributes such as (ii).
 * If NAME is of the form: xxx..yyyy, yyyy is assumed to be the played
 *  character name and is removed to get the cleaned name.
 * The attributes must come *before* the character.
 *
 * The worst line is:
 * williams, john (ii) (AAN) (GG) ...... Eeek Oook (ii) (not a monkey)
 *
 * Four results:
 *  - RCLEANEDNAME holds the cleaned name (without attribute)
 *  - RNEWNAME holds the reversed name (without attribute)
 *  - RATTRIBUTE holds the attribute or NULL if none.
 *  - RCHARNAME holds the character name or NULL if none.
 */
void rectify (const char *name,
              char **rcleanedname, char **rnewname,
              char **rattribute, char **rcharname);

#endif /* _RECTIFY_H */
